Weekly LeetCode Algorithm Questions (19) 279. Perfect Squares

Weekly LeetCode Algorithm Questions (19)

Subject: 279. Perfect Squares

Given a positive integer n, find the least number of perfect square numbers (for example, 1, 4, 9, 16, …) which sum to n.

For example, given n = 12, return 3 because 12 = 4 + 4 + 4; given n = 13, return 2 because 13 = 4 + 9.

solution analysis

This problem is basically the same as finding the number of paths to add to a specified number, but it is replaced by adding a square number each time.

C++ code

class Solution {
public:
    int numSquares(int n) {
        int * dp = new int[n + 1];
        dp[0] = 0;
        dp[1] = 1;
        for (int i = 2; i <= n; i++) {
            dp[i] = INT_MAX;
            for (int j = 1; j * j <= i; j++) {
                dp[i] = min(dp[i], dp[i - j * j] + 1);
            }
        }
        return dp[n];
    }
};

Guess you like

Origin http://43.154.161.224:23101/article/api/json?id=325643306&siteId=291194637